Index: NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/DYN/dynhpg.F90
===================================================================
--- NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/DYN/dynhpg.F90	(revision 14851)
+++ NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/DYN/dynhpg.F90	(revision 14852)
@@ -1107,158 +1101,153 @@
 !                         & r1_e1e2v(ji,jj) * vmask(ji,jj,1) * 0.5_wp 
 !!gm not this:
-       zsshu_n(ji,jj) = (e1e2u(ji,jj) * ssh(ji,jj,Kmm) + e1e2u(ji+1, jj) * ssh(ji+1,jj,Kmm)) * &
-                      & r1_e1e2u(ji,jj) * umask(ji,jj,1) * 0.5_wp 
-       zsshv_n(ji,jj) = (e1e2v(ji,jj) * ssh(ji,jj,Kmm) + e1e2v(ji+1, jj) * ssh(ji,jj+1,Kmm)) * &
-                      & r1_e1e2v(ji,jj) * vmask(ji,jj,1) * 0.5_wp 
-      END_2D
-
-      CALL lbc_lnk ('dynhpg', zsshu_n, 'U', 1.0_wp, zsshv_n, 'V', 1.0_wp )
+         zsshu_n(ji,jj) = (e1e2u(ji,jj) * ssh(ji,jj,Kmm) + e1e2u(ji+1, jj) * ssh(ji+1,jj,Kmm)) * &
+                        & r1_e1e2u(ji,jj) * umask(ji,jj,1) * 0.5_wp
+         zsshv_n(ji,jj) = (e1e2v(ji,jj) * ssh(ji,jj,Kmm) + e1e2v(ji+1, jj) * ssh(ji,jj+1,Kmm)) * &
+                        & r1_e1e2v(ji,jj) * vmask(ji,jj,1) * 0.5_wp
+      END_2D
 
       DO_2D( 0, 0, 0, 0 )
-       zu(ji,jj,1) = - ( e3u(ji,jj,1,Kmm) - zsshu_n(ji,jj) ) 
-       zv(ji,jj,1) = - ( e3v(ji,jj,1,Kmm) - zsshv_n(ji,jj) )
+         zu(ji,jj,1) = - ( e3u(ji,jj,1,Kmm) - zsshu_n(ji,jj) )
+         zv(ji,jj,1) = - ( e3v(ji,jj,1,Kmm) - zsshv_n(ji,jj) )
       END_2D
 
       DO_3D( 0, 0, 0, 0, 2, jpkm1 )
-      zu(ji,jj,jk) = zu(ji,jj,jk-1) - e3u(ji,jj,jk,Kmm)
-      zv(ji,jj,jk) = zv(ji,jj,jk-1) - e3v(ji,jj,jk,Kmm)
+         zu(ji,jj,jk) = zu(ji,jj,jk-1) - e3u(ji,jj,jk,Kmm)
+         zv(ji,jj,jk) = zv(ji,jj,jk-1) - e3v(ji,jj,jk,Kmm)
       END_3D
 
       DO_3D( 0, 0, 0, 0, 1, jpkm1 )
-      zu(ji,jj,jk) = zu(ji,jj,jk) + 0.5_wp * e3u(ji,jj,jk,Kmm)
-      zv(ji,jj,jk) = zv(ji,jj,jk) + 0.5_wp * e3v(ji,jj,jk,Kmm)
+         zu(ji,jj,jk) = zu(ji,jj,jk) + 0.5_wp * e3u(ji,jj,jk,Kmm)
+         zv(ji,jj,jk) = zv(ji,jj,jk) + 0.5_wp * e3v(ji,jj,jk,Kmm)
       END_3D
 
       DO_3D( 0, 0, 0, 0, 1, jpkm1 )
-      zu(ji,jj,jk) = MIN(  zu(ji,jj,jk) , MAX( -zdept(ji,jj,jk) , -zdept(ji+1,jj,jk) )  )
-      zu(ji,jj,jk) = MAX(  zu(ji,jj,jk) , MIN( -zdept(ji,jj,jk) , -zdept(ji+1,jj,jk) )  )
-      zv(ji,jj,jk) = MIN(  zv(ji,jj,jk) , MAX( -zdept(ji,jj,jk) , -zdept(ji,jj+1,jk) )  )
-      zv(ji,jj,jk) = MAX(  zv(ji,jj,jk) , MIN( -zdept(ji,jj,jk) , -zdept(ji,jj+1,jk) )  )
+         zu(ji,jj,jk) = MIN(  zu(ji,jj,jk) , MAX( -zdept(ji,jj,jk) , -zdept(ji+1,jj,jk) )  )
+         zu(ji,jj,jk) = MAX(  zu(ji,jj,jk) , MIN( -zdept(ji,jj,jk) , -zdept(ji+1,jj,jk) )  )
+         zv(ji,jj,jk) = MIN(  zv(ji,jj,jk) , MAX( -zdept(ji,jj,jk) , -zdept(ji,jj+1,jk) )  )
+         zv(ji,jj,jk) = MAX(  zv(ji,jj,jk) , MIN( -zdept(ji,jj,jk) , -zdept(ji,jj+1,jk) )  )
       END_3D
 
 
       DO_3D( 0, 0, 0, 0, 1, jpkm1 )
-      zpwes = 0._wp; zpwed = 0._wp
-      zpnss = 0._wp; zpnsd = 0._wp
-      zuijk = zu(ji,jj,jk)
-      zvijk = zv(ji,jj,jk)
-
-      !!!!!     for u equation
-      IF( jk <= mbku(ji,jj) ) THEN
-         IF( -zdept(ji+1,jj,jk) >= -zdept(ji,jj,jk) ) THEN
-           jis = ji + 1; jid = ji
-         ELSE
-           jis = ji;     jid = ji +1
+         zpwes = 0._wp; zpwed = 0._wp
+         zpnss = 0._wp; zpnsd = 0._wp
+         zuijk = zu(ji,jj,jk)
+         zvijk = zv(ji,jj,jk)
+
+         !!!!!     for u equation
+         IF( jk <= mbku(ji,jj) ) THEN
+            IF( -zdept(ji+1,jj,jk) >= -zdept(ji,jj,jk) ) THEN
+              jis = ji + 1; jid = ji
+            ELSE
+              jis = ji;     jid = ji +1
+            ENDIF
+
+            ! integrate the pressure on the shallow side
+            jk1 = jk
+            DO WHILE ( -zdept(jis,jj,jk1) > zuijk )
+               IF( jk1 == mbku(ji,jj) ) THEN
+                  zuijk = -zdept(jis,jj,jk1)
+                  EXIT
+               ENDIF
+               zdeps = MIN(zdept(jis,jj,jk1+1), -zuijk)
+               zpwes = zpwes +                                      &
+                  integ_spline(zdept(jis,jj,jk1), zdeps,            &
+                                 asp(jis,jj,jk1), bsp(jis,jj,jk1),  &
+                                 csp(jis,jj,jk1), dsp(jis,jj,jk1))
+               jk1 = jk1 + 1
+            END DO
+
+            ! integrate the pressure on the deep side
+            jk1 = jk
+            DO WHILE ( -zdept(jid,jj,jk1) < zuijk )
+               IF( jk1 == 1 ) THEN
+                  zdeps = zdept(jid,jj,1) + MIN(zuijk, ssh(jid,jj,Kmm)*znad)
+                  zrhdt1 = zrhh(jid,jj,1) - interp3(zdept(jid,jj,1), asp(jid,jj,1), &
+                                                    bsp(jid,jj,1)  , csp(jid,jj,1), &
+                                                    dsp(jid,jj,1)) * zdeps
+                  zpwed  = zpwed + 0.5_wp * (zrhh(jid,jj,1) + zrhdt1) * zdeps
+                  EXIT
+               ENDIF
+               zdeps = MAX(zdept(jid,jj,jk1-1), -zuijk)
+               zpwed = zpwed +                                        &
+                  integ_spline(zdeps,             zdept(jid,jj,jk1),  &
+                               asp(jid,jj,jk1-1), bsp(jid,jj,jk1-1),  &
+                               csp(jid,jj,jk1-1), dsp(jid,jj,jk1-1) )
+               jk1 = jk1 - 1
+            END DO
+
+            ! update the momentum trends in u direction
+            zdpdx1 = zcoef0 * r1_e1u(ji,jj) * ( zhpi(ji+1,jj,jk) - zhpi(ji,jj,jk) )
+            IF( .NOT.ln_linssh ) THEN
+               zdpdx2 = zcoef0 * r1_e1u(ji,jj) * &
+                  &    ( REAL(jis-jid, wp) * (zpwes + zpwed) + (ssh(ji+1,jj,Kmm)-ssh(ji,jj,Kmm)) )
+            ELSE
+               zdpdx2 = zcoef0 * r1_e1u(ji,jj) * REAL(jis-jid, wp) * (zpwes + zpwed)
+            ENDIF
+            IF( ln_wd_il ) THEN
+               zdpdx1 = zdpdx1 * zcpx(ji,jj) * wdrampu(ji,jj)
+               zdpdx2 = zdpdx2 * zcpx(ji,jj) * wdrampu(ji,jj)
+            ENDIF
+            puu(ji,jj,jk,Krhs) = puu(ji,jj,jk,Krhs) + (zdpdx1 + zdpdx2 - zpgu(ji,jj)) * umask(ji,jj,jk)
          ENDIF
 
-         ! integrate the pressure on the shallow side
-         jk1 = jk
-         DO WHILE ( -zdept(jis,jj,jk1) > zuijk )
-           IF( jk1 == mbku(ji,jj) ) THEN
-             zuijk = -zdept(jis,jj,jk1)
-             EXIT
-           ENDIF
-           zdeps = MIN(zdept(jis,jj,jk1+1), -zuijk)
-           zpwes = zpwes +                                    &
-                integ_spline(zdept(jis,jj,jk1), zdeps,            &
-                       asp(jis,jj,jk1),    bsp(jis,jj,jk1), &
-                       csp(jis,jj,jk1),    dsp(jis,jj,jk1))
-           jk1 = jk1 + 1
-         END DO
-
-         ! integrate the pressure on the deep side
-         jk1 = jk
-         DO WHILE ( -zdept(jid,jj,jk1) < zuijk )
-           IF( jk1 == 1 ) THEN
-             zdeps = zdept(jid,jj,1) + MIN(zuijk, ssh(jid,jj,Kmm)*znad)
-             zrhdt1 = zrhh(jid,jj,1) - interp3(zdept(jid,jj,1), asp(jid,jj,1), &
-                                               bsp(jid,jj,1),   csp(jid,jj,1), &
-                                               dsp(jid,jj,1)) * zdeps
-             zpwed  = zpwed + 0.5_wp * (zrhh(jid,jj,1) + zrhdt1) * zdeps
-             EXIT
-           ENDIF
-           zdeps = MAX(zdept(jid,jj,jk1-1), -zuijk)
-           zpwed = zpwed +                                        &
-                  integ_spline(zdeps,              zdept(jid,jj,jk1), &
-                         asp(jid,jj,jk1-1), bsp(jid,jj,jk1-1),  &
-                         csp(jid,jj,jk1-1), dsp(jid,jj,jk1-1) )
-           jk1 = jk1 - 1
-         END DO
-
-         ! update the momentum trends in u direction
-
-         zdpdx1 = zcoef0 * r1_e1u(ji,jj) * ( zhpi(ji+1,jj,jk) - zhpi(ji,jj,jk) )
-         IF( .NOT.ln_linssh ) THEN
-           zdpdx2 = zcoef0 * r1_e1u(ji,jj) * &
-              &    ( REAL(jis-jid, wp) * (zpwes + zpwed) + (ssh(ji+1,jj,Kmm)-ssh(ji,jj,Kmm)) )
-          ELSE
-           zdpdx2 = zcoef0 * r1_e1u(ji,jj) * REAL(jis-jid, wp) * (zpwes + zpwed)
+         !!!!!     for v equation
+         IF( jk <= mbkv(ji,jj) ) THEN
+            IF( -zdept(ji,jj+1,jk) >= -zdept(ji,jj,jk) ) THEN
+               jjs = jj + 1; jjd = jj
+            ELSE
+               jjs = jj    ; jjd = jj + 1
+            ENDIF
+
+            ! integrate the pressure on the shallow side
+            jk1 = jk
+            DO WHILE ( -zdept(ji,jjs,jk1) > zvijk )
+               IF( jk1 == mbkv(ji,jj) ) THEN
+                  zvijk = -zdept(ji,jjs,jk1)
+                  EXIT
+               ENDIF
+               zdeps = MIN(zdept(ji,jjs,jk1+1), -zvijk)
+               zpnss = zpnss +                                       &
+                  integ_spline(zdept(ji,jjs,jk1), zdeps,             &
+                               asp(ji,jjs,jk1),   bsp(ji,jjs,jk1),   &
+                               csp(ji,jjs,jk1),   dsp(ji,jjs,jk1) )
+              jk1 = jk1 + 1
+            END DO
+
+            ! integrate the pressure on the deep side
+            jk1 = jk
+            DO WHILE ( -zdept(ji,jjd,jk1) < zvijk )
+               IF( jk1 == 1 ) THEN
+                  zdeps = zdept(ji,jjd,1) + MIN(zvijk, ssh(ji,jjd,Kmm)*znad)
+                  zrhdt1 = zrhh(ji,jjd,1) - interp3(zdept(ji,jjd,1), asp(ji,jjd,1), &
+                                                    bsp(ji,jjd,1)  , csp(ji,jjd,1), &
+                                                    dsp(ji,jjd,1) ) * zdeps
+                  zpnsd  = zpnsd + 0.5_wp * (zrhh(ji,jjd,1) + zrhdt1) * zdeps
+                  EXIT
+               ENDIF
+               zdeps = MAX(zdept(ji,jjd,jk1-1), -zvijk)
+               zpnsd = zpnsd +                                        &
+                  integ_spline(zdeps,             zdept(ji,jjd,jk1),  &
+                               asp(ji,jjd,jk1-1), bsp(ji,jjd,jk1-1),  &
+                               csp(ji,jjd,jk1-1), dsp(ji,jjd,jk1-1) )
+               jk1 = jk1 - 1
+            END DO
+
+            ! update the momentum trends in v direction
+            zdpdy1 = zcoef0 * r1_e2v(ji,jj) * ( zhpi(ji,jj+1,jk) - zhpi(ji,jj,jk) )
+            IF( .NOT.ln_linssh ) THEN
+               zdpdy2 = zcoef0 * r1_e2v(ji,jj) * &
+                       ( REAL(jjs-jjd, wp) * (zpnss + zpnsd) + (ssh(ji,jj+1,Kmm)-ssh(ji,jj,Kmm)) )
+            ELSE
+               zdpdy2 = zcoef0 * r1_e2v(ji,jj) * REAL(jjs-jjd, wp) * (zpnss + zpnsd )
+            ENDIF
+            IF( ln_wd_il ) THEN
+               zdpdy1 = zdpdy1 * zcpy(ji,jj) * wdrampv(ji,jj)
+               zdpdy2 = zdpdy2 * zcpy(ji,jj) * wdrampv(ji,jj)
+            ENDIF
+
+            pvv(ji,jj,jk,Krhs) = pvv(ji,jj,jk,Krhs) + (zdpdy1 + zdpdy2 - zpgv(ji,jj)) * vmask(ji,jj,jk)
          ENDIF
-         IF( ln_wd_il ) THEN
-            zdpdx1 = zdpdx1 * zcpx(ji,jj) * wdrampu(ji,jj)
-            zdpdx2 = zdpdx2 * zcpx(ji,jj) * wdrampu(ji,jj)
-         ENDIF
-         puu(ji,jj,jk,Krhs) = puu(ji,jj,jk,Krhs) + (zdpdx1 + zdpdx2 - zpgu(ji,jj)) * umask(ji,jj,jk) 
-      ENDIF
-
-      !!!!!     for v equation
-      IF( jk <= mbkv(ji,jj) ) THEN
-         IF( -zdept(ji,jj+1,jk) >= -zdept(ji,jj,jk) ) THEN
-           jjs = jj + 1; jjd = jj
-         ELSE
-           jjs = jj    ; jjd = jj + 1
-         ENDIF
-
-         ! integrate the pressure on the shallow side
-         jk1 = jk
-         DO WHILE ( -zdept(ji,jjs,jk1) > zvijk )
-           IF( jk1 == mbkv(ji,jj) ) THEN
-             zvijk = -zdept(ji,jjs,jk1)
-             EXIT
-           ENDIF
-           zdeps = MIN(zdept(ji,jjs,jk1+1), -zvijk)
-           zpnss = zpnss +                                      &
-                  integ_spline(zdept(ji,jjs,jk1), zdeps,            &
-                         asp(ji,jjs,jk1),    bsp(ji,jjs,jk1), &
-                         csp(ji,jjs,jk1),    dsp(ji,jjs,jk1) )
-           jk1 = jk1 + 1
-         END DO
-
-         ! integrate the pressure on the deep side
-         jk1 = jk
-         DO WHILE ( -zdept(ji,jjd,jk1) < zvijk )
-           IF( jk1 == 1 ) THEN
-             zdeps = zdept(ji,jjd,1) + MIN(zvijk, ssh(ji,jjd,Kmm)*znad)
-             zrhdt1 = zrhh(ji,jjd,1) - interp3(zdept(ji,jjd,1), asp(ji,jjd,1), &
-                                               bsp(ji,jjd,1),   csp(ji,jjd,1), &
-                                               dsp(ji,jjd,1) ) * zdeps
-             zpnsd  = zpnsd + 0.5_wp * (zrhh(ji,jjd,1) + zrhdt1) * zdeps
-             EXIT
-           ENDIF
-           zdeps = MAX(zdept(ji,jjd,jk1-1), -zvijk)
-           zpnsd = zpnsd +                                        &
-                  integ_spline(zdeps,              zdept(ji,jjd,jk1), &
-                         asp(ji,jjd,jk1-1), bsp(ji,jjd,jk1-1), &
-                         csp(ji,jjd,jk1-1), dsp(ji,jjd,jk1-1) )
-           jk1 = jk1 - 1
-         END DO
-
-
-         ! update the momentum trends in v direction
-
-         zdpdy1 = zcoef0 * r1_e2v(ji,jj) * ( zhpi(ji,jj+1,jk) - zhpi(ji,jj,jk) )
-         IF( .NOT.ln_linssh ) THEN
-            zdpdy2 = zcoef0 * r1_e2v(ji,jj) * &
-                    ( REAL(jjs-jjd, wp) * (zpnss + zpnsd) + (ssh(ji,jj+1,Kmm)-ssh(ji,jj,Kmm)) )
-         ELSE
-            zdpdy2 = zcoef0 * r1_e2v(ji,jj) * REAL(jjs-jjd, wp) * (zpnss + zpnsd )
-         ENDIF
-         IF( ln_wd_il ) THEN
-            zdpdy1 = zdpdy1 * zcpy(ji,jj) * wdrampv(ji,jj) 
-            zdpdy2 = zdpdy2 * zcpy(ji,jj) * wdrampv(ji,jj) 
-         ENDIF
-
-         pvv(ji,jj,jk,Krhs) = pvv(ji,jj,jk,Krhs) + (zdpdy1 + zdpdy2 - zpgv(ji,jj)) * vmask(ji,jj,jk)
-      ENDIF
          !
       END_3D
@@ -1279,91 +1268,79 @@
       !! Reference: CJC Kruger, Constrained Cubic Spline Interpoltation
       !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(:,:,:), INTENT(in   ) ::   fsp, xsp           ! value and coordinate
-      REAL(wp), DIMENSION(:,:,:), INTENT(  out) ::   asp, bsp, csp, dsp ! coefficients of the interpoated function
-      INTEGER                   , INTENT(in   ) ::   polynomial_type    ! 1: cubic spline   ;   2: Linear
+      REAL(wp), DIMENSION(A2D(nn_hls),jpk), INTENT(in   ) ::   fsp, xsp           ! value and coordinate
+      REAL(wp), DIMENSION(A2D(nn_hls),jpk), INTENT(  out) ::   asp, bsp, csp, dsp ! coefficients of the interpoated function
+      INTEGER                             , INTENT(in   ) ::   polynomial_type    ! 1: cubic spline   ;   2: Linear
       !
       INTEGER  ::   ji, jj, jk                 ! dummy loop indices
-      INTEGER  ::   jpi, jpj, jpkm1
       REAL(wp) ::   zdf1, zdf2, zddf1, zddf2, ztmp1, ztmp2, zdxtmp
       REAL(wp) ::   zdxtmp1, zdxtmp2, zalpha
-      REAL(wp) ::   zdf(size(fsp,3))
-      !!----------------------------------------------------------------------
-      !
-!!gm  WHAT !!!!!   THIS IS VERY DANGEROUS !!!!!  
-      jpi   = size(fsp,1)
-      jpj   = size(fsp,2)
-      jpkm1 = MAX( 1, size(fsp,3) - 1 )
+      REAL(wp) ::   zdf(jpk)
+      !!----------------------------------------------------------------------
       !
       IF (polynomial_type == 1) THEN     ! Constrained Cubic Spline
-         DO ji = 1, jpi
-            DO jj = 1, jpj
-           !!Fritsch&Butland's method, 1984 (preferred, but more computation)
-           !    DO jk = 2, jpkm1-1
-           !       zdxtmp1 = xsp(ji,jj,jk)   - xsp(ji,jj,jk-1)
-           !       zdxtmp2 = xsp(ji,jj,jk+1) - xsp(ji,jj,jk)
-           !       zdf1    = ( fsp(ji,jj,jk)   - fsp(ji,jj,jk-1) ) / zdxtmp1
-           !       zdf2    = ( fsp(ji,jj,jk+1) - fsp(ji,jj,jk)   ) / zdxtmp2
-           !
-           !       zalpha = ( zdxtmp1 + 2._wp * zdxtmp2 ) / ( zdxtmp1 + zdxtmp2 ) / 3._wp
-           !
-           !       IF(zdf1 * zdf2 <= 0._wp) THEN
-           !           zdf(jk) = 0._wp
-           !       ELSE
-           !         zdf(jk) = zdf1 * zdf2 / ( ( 1._wp - zalpha ) * zdf1 + zalpha * zdf2 )
-           !       ENDIF
-           !    END DO
-
-           !!Simply geometric average
-               DO jk = 2, jpkm1-1
-                  zdf1 = (fsp(ji,jj,jk  ) - fsp(ji,jj,jk-1)) / (xsp(ji,jj,jk  ) - xsp(ji,jj,jk-1))
-                  zdf2 = (fsp(ji,jj,jk+1) - fsp(ji,jj,jk  )) / (xsp(ji,jj,jk+1) - xsp(ji,jj,jk  ))
-
-                  IF(zdf1 * zdf2 <= 0._wp) THEN
-                     zdf(jk) = 0._wp
-                  ELSE
-                     zdf(jk) = 2._wp * zdf1 * zdf2 / (zdf1 + zdf2)
-                  ENDIF
-               END DO
-
-               zdf(1)     = 1.5_wp * ( fsp(ji,jj,2) - fsp(ji,jj,1) ) / &
-                          &          ( xsp(ji,jj,2) - xsp(ji,jj,1) )           -  0.5_wp * zdf(2)
-               zdf(jpkm1) = 1.5_wp * ( fsp(ji,jj,jpkm1) - fsp(ji,jj,jpkm1-1) ) / &
-                          &          ( xsp(ji,jj,jpkm1) - xsp(ji,jj,jpkm1-1) ) - 0.5_wp * zdf(jpkm1 - 1)
-
-               DO jk = 1, jpkm1 - 1
-                 zdxtmp = xsp(ji,jj,jk+1) - xsp(ji,jj,jk)
-                 ztmp1  = (zdf(jk+1) + 2._wp * zdf(jk)) / zdxtmp
-                 ztmp2  =  6._wp * (fsp(ji,jj,jk+1) - fsp(ji,jj,jk)) / zdxtmp / zdxtmp
-                 zddf1  = -2._wp * ztmp1 + ztmp2
-                 ztmp1  = (2._wp * zdf(jk+1) + zdf(jk)) / zdxtmp
-                 zddf2  =  2._wp * ztmp1 - ztmp2
-
-                 dsp(ji,jj,jk) = (zddf2 - zddf1) / 6._wp / zdxtmp
-                 csp(ji,jj,jk) = ( xsp(ji,jj,jk+1) * zddf1 - xsp(ji,jj,jk)*zddf2 ) / 2._wp / zdxtmp
-                 bsp(ji,jj,jk) = ( fsp(ji,jj,jk+1) - fsp(ji,jj,jk) ) / zdxtmp - &
-                               & csp(ji,jj,jk) * ( xsp(ji,jj,jk+1) + xsp(ji,jj,jk) ) - &
-                               & dsp(ji,jj,jk) * ((xsp(ji,jj,jk+1) + xsp(ji,jj,jk))**2 - &
-                               &                   xsp(ji,jj,jk+1) * xsp(ji,jj,jk))
-                 asp(ji,jj,jk) = fsp(ji,jj,jk) - xsp(ji,jj,jk) * (bsp(ji,jj,jk) + &
-                               &                (xsp(ji,jj,jk) * (csp(ji,jj,jk) + &
-                               &                 dsp(ji,jj,jk) * xsp(ji,jj,jk))))
-               END DO
+         DO_2D( 1, 1, 1, 1 )
+            !!Fritsch&Butland's method, 1984 (preferred, but more computation)
+            !    DO jk = 2, jpkm1-1
+            !       zdxtmp1 = xsp(ji,jj,jk)   - xsp(ji,jj,jk-1)
+            !       zdxtmp2 = xsp(ji,jj,jk+1) - xsp(ji,jj,jk)
+            !       zdf1    = ( fsp(ji,jj,jk)   - fsp(ji,jj,jk-1) ) / zdxtmp1
+            !       zdf2    = ( fsp(ji,jj,jk+1) - fsp(ji,jj,jk)   ) / zdxtmp2
+            !
+            !       zalpha = ( zdxtmp1 + 2._wp * zdxtmp2 ) / ( zdxtmp1 + zdxtmp2 ) / 3._wp
+            !
+            !       IF(zdf1 * zdf2 <= 0._wp) THEN
+            !           zdf(jk) = 0._wp
+            !       ELSE
+            !         zdf(jk) = zdf1 * zdf2 / ( ( 1._wp - zalpha ) * zdf1 + zalpha * zdf2 )
+            !       ENDIF
+            !    END DO
+
+            !!Simply geometric average
+            DO jk = 2, jpk-2
+               zdf1 = (fsp(ji,jj,jk  ) - fsp(ji,jj,jk-1)) / (xsp(ji,jj,jk  ) - xsp(ji,jj,jk-1))
+               zdf2 = (fsp(ji,jj,jk+1) - fsp(ji,jj,jk  )) / (xsp(ji,jj,jk+1) - xsp(ji,jj,jk  ))
+
+               IF(zdf1 * zdf2 <= 0._wp) THEN
+                  zdf(jk) = 0._wp
+               ELSE
+                  zdf(jk) = 2._wp * zdf1 * zdf2 / (zdf1 + zdf2)
+               ENDIF
             END DO
-         END DO
+
+            zdf(1)     = 1.5_wp * ( fsp(ji,jj,2) - fsp(ji,jj,1) ) / &
+                       &          ( xsp(ji,jj,2) - xsp(ji,jj,1) )           -  0.5_wp * zdf(2)
+            zdf(jpkm1) = 1.5_wp * ( fsp(ji,jj,jpkm1) - fsp(ji,jj,jpkm1-1) ) / &
+                       &          ( xsp(ji,jj,jpkm1) - xsp(ji,jj,jpkm1-1) ) - 0.5_wp * zdf(jpk - 2)
+
+            DO jk = 1, jpk-2
+               zdxtmp = xsp(ji,jj,jk+1) - xsp(ji,jj,jk)
+               ztmp1  = (zdf(jk+1) + 2._wp * zdf(jk)) / zdxtmp
+               ztmp2  =  6._wp * (fsp(ji,jj,jk+1) - fsp(ji,jj,jk)) / zdxtmp / zdxtmp
+               zddf1  = -2._wp * ztmp1 + ztmp2
+               ztmp1  = (2._wp * zdf(jk+1) + zdf(jk)) / zdxtmp
+               zddf2  =  2._wp * ztmp1 - ztmp2
+
+               dsp(ji,jj,jk) = (zddf2 - zddf1) / 6._wp / zdxtmp
+               csp(ji,jj,jk) = ( xsp(ji,jj,jk+1) * zddf1 - xsp(ji,jj,jk)*zddf2 ) / 2._wp / zdxtmp
+               bsp(ji,jj,jk) = ( fsp(ji,jj,jk+1) - fsp(ji,jj,jk) ) / zdxtmp - &
+                             & csp(ji,jj,jk) * ( xsp(ji,jj,jk+1) + xsp(ji,jj,jk) ) - &
+                             & dsp(ji,jj,jk) * ((xsp(ji,jj,jk+1) + xsp(ji,jj,jk))**2 - &
+                             &                   xsp(ji,jj,jk+1) * xsp(ji,jj,jk))
+               asp(ji,jj,jk) = fsp(ji,jj,jk) - xsp(ji,jj,jk) * (bsp(ji,jj,jk) + &
+                             &                (xsp(ji,jj,jk) * (csp(ji,jj,jk) + &
+                             &                 dsp(ji,jj,jk) * xsp(ji,jj,jk))))
+            END DO
+         END_2D
 
       ELSEIF ( polynomial_type == 2 ) THEN     ! Linear
-         DO ji = 1, jpi
-            DO jj = 1, jpj
-               DO jk = 1, jpkm1-1
-                  zdxtmp =xsp(ji,jj,jk+1) - xsp(ji,jj,jk)
-                  ztmp1 = fsp(ji,jj,jk+1) - fsp(ji,jj,jk)
-
-                  dsp(ji,jj,jk) = 0._wp
-                  csp(ji,jj,jk) = 0._wp
-                  bsp(ji,jj,jk) = ztmp1 / zdxtmp
-                  asp(ji,jj,jk) = fsp(ji,jj,jk) - bsp(ji,jj,jk) * xsp(ji,jj,jk)
-               END DO
-            END DO
-         END DO
+         DO_3D( 1, 1, 1, 1, 1, jpk-2 )
+            zdxtmp =xsp(ji,jj,jk+1) - xsp(ji,jj,jk)
+            ztmp1 = fsp(ji,jj,jk+1) - fsp(ji,jj,jk)
+
+            dsp(ji,jj,jk) = 0._wp
+            csp(ji,jj,jk) = 0._wp
+            bsp(ji,jj,jk) = ztmp1 / zdxtmp
+            asp(ji,jj,jk) = fsp(ji,jj,jk) - bsp(ji,jj,jk) * xsp(ji,jj,jk)
+         END_3D
          !
       ELSE
Index: NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/DYN/dynkeg.F90
===================================================================
--- NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/DYN/dynkeg.F90	(revision 14851)
+++ NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/DYN/dynkeg.F90	(revision 14852)
@@ -78,5 +78,5 @@
       INTEGER  ::   ji, jj, jk             ! dummy loop indices
       REAL(wp) ::   zu, zv                   ! local scalars
-      REAL(wp), DIMENSION(jpi,jpj,jpk)        ::   zhke
+      REAL(wp), DIMENSION(A2D(nn_hls),jpk)    ::   zhke
       REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   ztrdu, ztrdv 
       !!----------------------------------------------------------------------
@@ -84,8 +84,10 @@
       IF( ln_timing )   CALL timing_start('dyn_keg')
       !
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'dyn_keg : kinetic energy gradient trend, scheme number=', kscheme
-         IF(lwp) WRITE(numout,*) '~~~~~~~'
+      IF( .NOT. l_istiled .OR. ntile == 1 )  THEN                       ! Do only on the first tile
+         IF( kt == nit000 ) THEN
+            IF(lwp) WRITE(numout,*)
+            IF(lwp) WRITE(numout,*) 'dyn_keg : kinetic energy gradient trend, scheme number=', kscheme
+            IF(lwp) WRITE(numout,*) '~~~~~~~'
+         ENDIF
       ENDIF
 
@@ -109,17 +111,21 @@
          END_3D
       CASE ( nkeg_HW )                          !--  Hollingsworth scheme  --!
-         DO_3D( 0, 0, 0, 0, 1, jpkm1 )
+         DO_3D( 0, nn_hls-1, 0, nn_hls-1, 1, jpkm1 )
+            ! round brackets added to fix the order of floating point operations
+            ! needed to ensure halo 1 - halo 2 compatibility
             zu = 8._wp * ( puu(ji-1,jj  ,jk,Kmm) * puu(ji-1,jj  ,jk,Kmm)    &
                &         + puu(ji  ,jj  ,jk,Kmm) * puu(ji  ,jj  ,jk,Kmm) )  &
-               &   +     ( puu(ji-1,jj-1,jk,Kmm) + puu(ji-1,jj+1,jk,Kmm) ) * ( puu(ji-1,jj-1,jk,Kmm) + puu(ji-1,jj+1,jk,Kmm) )   &
-               &   +     ( puu(ji  ,jj-1,jk,Kmm) + puu(ji  ,jj+1,jk,Kmm) ) * ( puu(ji  ,jj-1,jk,Kmm) + puu(ji  ,jj+1,jk,Kmm) )
+               &   +     ( ( puu(ji-1,jj-1,jk,Kmm) + puu(ji-1,jj+1,jk,Kmm) ) * ( puu(ji-1,jj-1,jk,Kmm) + puu(ji-1,jj+1,jk,Kmm) )   &
+               &   +       ( puu(ji  ,jj-1,jk,Kmm) + puu(ji  ,jj+1,jk,Kmm) ) * ( puu(ji  ,jj-1,jk,Kmm) + puu(ji  ,jj+1,jk,Kmm) )   &
+               &         )                                                               ! bracket for halo 1 - halo 2 compatibility
                !
             zv = 8._wp * ( pvv(ji  ,jj-1,jk,Kmm) * pvv(ji  ,jj-1,jk,Kmm)    &
                &         + pvv(ji  ,jj  ,jk,Kmm) * pvv(ji  ,jj  ,jk,Kmm) )  &
-               &  +      ( pvv(ji-1,jj-1,jk,Kmm) + pvv(ji+1,jj-1,jk,Kmm) ) * ( pvv(ji-1,jj-1,jk,Kmm) + pvv(ji+1,jj-1,jk,Kmm) )   &
-               &  +      ( pvv(ji-1,jj  ,jk,Kmm) + pvv(ji+1,jj  ,jk,Kmm) ) * ( pvv(ji-1,jj  ,jk,Kmm) + pvv(ji+1,jj  ,jk,Kmm) )
+               &  +      ( ( pvv(ji-1,jj-1,jk,Kmm) + pvv(ji+1,jj-1,jk,Kmm) ) * ( pvv(ji-1,jj-1,jk,Kmm) + pvv(ji+1,jj-1,jk,Kmm) )  &
+               &  +        ( pvv(ji-1,jj  ,jk,Kmm) + pvv(ji+1,jj  ,jk,Kmm) ) * ( pvv(ji-1,jj  ,jk,Kmm) + pvv(ji+1,jj  ,jk,Kmm) )  &
+               &         )                                                               ! bracket for halo 1 - halo 2 compatibility
             zhke(ji,jj,jk) = r1_48 * ( zv + zu )
          END_3D
-         CALL lbc_lnk( 'dynkeg', zhke, 'T', 1.0_wp )
+         IF (nn_hls==1) CALL lbc_lnk( 'dynkeg', zhke, 'T', 1.0_wp )
          !
       END SELECT 
